#include <dos.h>
/////////// Happytxt.cpp

void TSR_screen (void);
unsigned char video_params(void);
void get_text(int, int, int, int, unsigned *);
void put_text(int, int, int, int, unsigned *);
char Happy (void);
char kbscan(void);
void centerstr (int,int,int,char *,unsigned char);
void print_mess (char ,char ,unsigned char *,unsigned char);
int strlen_(char *);
char *strrev_(char *);
char *itoa_ (int ,char *s);
void write_char(int,int,unsigned char,unsigned char);
void goto_xy(char,char);
void Sound( int, int);
char randcount(void);

unsigned char far *vid_adr=(unsigned char far *)0xB8000000L;
unsigned vid_memory = 0xB800, start_adr, max_str, max_stolb;
///////////
#define YES 1
#define NO 0
#define    OK 0

unsigned TSR_ss, TSR_sp, TSR_screen_ss, TSR_screen_sp;
 // 祭 SS, SP  p TSR
unsigned TSR_stack[512], TSR_screen_stack[512]; 
 // ᯮ  ⥪ TSR
unsigned old_ss, old_sp, old_screen_ss, old_screen_sp; 
 // "p" SS, SP p 室  TSR
unsigned old_PSP;  // p PID 䮭 pp
unsigned inside_BIOS = NO, busy = NO, request = NO, unload = NO; // 䫠 TSR
char far * inside_DOS_ptr; // p 䫠 p 室  DOS 
char far * old_DTA;        // p p DTA
char far * TC_DTA;         // ap DTA, ᯮ㥬 Turbo C
int old_cbrk; //  Ctrl-Break;

void interrupt (* old_int24)(void); 
void interrupt (* old_int9 )(void); // ⥫  
void interrupt (* old_int13)(void); // 㭪樨 ࠡ⪨ 뢠
void interrupt (* old_int1C)(void);
void interrupt (* old_int28)(void);
void interrupt (* old_int2F)(void);

// p⨯ ᮡ⢥ 㭪権
void interrupt ISR_int28(void);
void interrupt ISR_int1C(void);
void interrupt ISR_int9 (void);
void interrupt ISR_int13 ();
void interrupt ISR_int24 ();
void interrupt ISR_int2F(void);
void tsr(char status, unsigned size);
int is_installed(void);
void TSR_screen (void); // ⢨  ࠭ -   ..
void TSR_prepare_activate(void); // ⮢ ⨢ TSR_body()
void TSR_body(void); // 筠 -㭪 - ࠡ  ᪮,   ..
int TSR_exit(void); // 믮 p㧪 TSR  

extern unsigned _heaplen = 1024; //  pp ""
extern unsigned _stklen  = 512;  //  pp ⥪


#define SHIFT_MASK 0x000c	/* CTRL ALT */
#define SCAN_CODE 0x23		/* H */
//   ࠡ稪 뢠  .  ६ 
//   ⨨    ᪥ SHIFT_MASK   
//   - SCAN_CODE 뢠, ।⥫쭮 
//   ४稢 ⥪, 㭪 TSR_screen().  ᫨ 譨 
//   ६ request  unload ࠢ YES,  㪮 
//   ᨣ  ࠧ 뢠 "" ࠡ稪. ᪠ 
//   ६ inside  ୮ 宦  ISR.  
static unsigned inside;
void interrupt ISR_int9(void) {
 old_int9();    // 맮 ண ࠡ稪 뢠 9
 disable();
 if(inside == NO) {
  inside = YES;
  if(request != YES || unload != YES) {
   // ஢ઠ ⮣,    .
   if((bioskey(2) & SHIFT_MASK) == SHIFT_MASK) 
   if(inportb(0x60) == SCAN_CODE) {
    bioskey(0); /* 㤠 ᨬ 'S'    */
    /* ४祭 ⥪  㭪樨 TSR_screen(). */
    old_screen_ss = _SS; old_screen_sp = _SP;
    disable();  /*  ⠭  SS,SP -  뢠 */
    _SS = TSR_screen_ss; _SP = TSR_screen_sp;
    enable();
    TSR_screen();
    // ⭮ ४祭 ⥪.
    disable();  // ⠭  SS,SP -  뢠
    _SS = old_screen_ss; _SP = old_screen_sp;
   }
  }
  else	Sound(500, 500); // ᨣ 1000  ⥫쭮 1 ᥪ.
  inside = NO;
 }
}

//  뢠 13h BIOS - ࠢ ᪮. ⠭  
// 祭 1 ६ inside_BIOS,  ⨢ 뢠 13h.
void interrupt ISR_int13 (unsigned bp, unsigned di, unsigned si,
 unsigned ds, unsigned es, unsigned dx,
 unsigned cx, unsigned bx, unsigned out_ax,
 unsigned ip, unsigned cs, unsigned out_flags) {
 inside_BIOS = YES;
 old_int13();
 disable(); // p 室  ISR 䫠 ⠭  ⥪ 
 out_ax = _AX;   // p p樨, p  BIOS 
 asm {           //  p pp
  pushf
  pop out_flags;
 }
 inside_BIOS = NO;
}

//   ISR 뢠  ⠩.  譨 䫠
//   request  unload , ᫨  ࠢ YES, ஢ ﭨ
//   BIOS  MS-DOS. ᫨ 䮭 ணࠬ -  BIOS-ISR 뢠
//   13h   MS-DOS  ॥ࠡ쭮 ᥪ樨, 뢠 㭪
//   TSR_prepare_activate.
void interrupt ISR_int1C(void) {
 old_int1C(); // cp ISR pp뢠 ⠩p 
 disable();
 if(busy == NO) {
  busy = YES;
  if(request == YES || unload == YES) {
   if( *inside_DOS_ptr == 1) { // MS-DOS 
    busy = NO; return; }
   if(inside_BIOS == YES) {
    busy = NO; return; }
   outportb(0x20, 0x20); // 뤠  EOI  pp pp뢠
   enable();
   TSR_prepare_activate(); // ⨢ TSR
   request = NO; busy = NO;
  }
  busy = NO;
 }
 return;
}

// ISR pp뢠 28h: ᫨  "⫮" ⪨
// ⨢樨  ⨢樨 TSR, 뢠 㭪
// TSR_prepare_activate().
void interrupt ISR_int28(void) {
 old_int28();    // 맮 p ISR pp뢠 28h
 disable();      // ᪨p㥬 p pp뢠
 if(busy == NO){
  busy = YES;
  if (request == YES || unload == YES)
   TSR_prepare_activate(); // ⨢ TSR
  request = NO;  busy = NO;
 }
 return;
}

//   믮 "p㧪" p⭮ pp. p:
//   NO (0) - p㧪 TSR    ;
//   YES(1) - p㧪 TSR 믮 ᯥ譮.
extern unsigned _psp;
int TSR_exit(void) {
 register env_seg, handle = 0;
 disable();
 // pp  ᭮ p㧪 TSR.
 if(getvect(9) != ISR_int9  || getvect(0x13) != ISR_int13 ||
    getvect(0x1C) != ISR_int1C || getvect(0x28) != ISR_int28 ||
    getvect(0x2F) != ISR_int2F) return NO;
    // p㧪     ⥬ ᭠
 setvect(0x9,  old_int9 );
 setvect(0x13, old_int13);
 setvect(0x1C, old_int1C);
 setvect(0x28, old_int28);
 setvect(0x2F, old_int2F);
 // ᢮ , ⮩ TSR.
 freemem(_psp);
 env_seg = *(unsigned far *)MK_FP(_psp, 0x2c);
 freemem(env_seg);
 // p⨥ p 䠩.
 //for(handle = 0; handle < 5; handle++) close(handle);
 enable();
 return YES;
}

//   ⮢ ⨢ p⭮ 㭪樨: p砥 ⥪,
//    p   PSP, ⠭ p
//   p  p 訡  Ctrl-Break. ᫨ ⠭
//   䫠 request, 뢠 TSR_body(). ᫨  p
//   unload = YES, 믮 "p㧪" TSR   㭪樥
//   TSR_exit(). ⥬ ⠭ ⥬  ﭨ  맮  TSR.
void TSR_prepare_activate() {
 // p祭 ⥪.
 disable(); old_ss = _SS; old_sp = _SP;
 _SS = TSR_ss; _SP = TSR_sp;  _BP = _SP;
 // p祭 ⥪饣 PSP  PSP p⭮ pp.
 _AH = 0x62;  geninterrupt(0x21);
 old_PSP = _BX;  _AH = 0x50;  _BX = _psp;
 geninterrupt(0x21);
 old_DTA = getdta();        // p ⥪饩 DTA
 setdta(TC_DTA);            // p祭  DTA Turbo C.
 old_int24 = getvect(0x24); // p ⥪饣 p 24h
 setvect(0x24, ISR_int24);  // ⠭ ᮡ⢥ ISR
 old_cbrk = getcbrk();      // p ⥪饩 p樨
 setcbrk(0);                // ⠭ CTRL-BREAK = OFF
 enable();                  // pp蠥 pp뢠
 if(request == YES) TSR_body();
 if(unload == YES) if(TSR_exit() == NO) {
  Sound (3000, 500); // ᨣ 3000  ⥫쭮 0.5 ᥪ
  unload = NO;       //     믮
 }
 disable();     //  p頥 pp뢠  pp
 setcbrk(old_cbrk);         // ⠭ p樨
 setvect(0x24, old_int24);  // p⭮ p祭
 setdta(old_DTA);           // p⭮ p祭 DTA
 // p⭮ p祭 PSP  PSP 䮭 pp.
 _AH = 0x50;  _BX = old_PSP;  geninterrupt(0x21);
 // p⭮ p祭 ⥪.
 _SS = old_ss;  _SP = old_sp;  return;
}

// "誠" pp뢠 24h - p᪠ 訡 MS-DOS. p
// AX = 3 - p  p pp  樥 訡 MS-DOS.
void interrupt ISR_int24 (unsigned bp, unsigned di, unsigned si,
 unsigned ds, unsigned es, unsigned dx,
 unsigned cx, unsigned bx, unsigned out_ax,
 unsigned ip, unsigned cs, unsigned out_flags) {
  out_ax = 3;     /* p p樨  MS-DOS */
}

//   p ⮣,    ᪠ ISR pp뢠 2Fh
//   "䨫", ॠ騩  祭  AX=0xF000 ⠭ AL=0xFF.
int is_installed(void) {
 union REGS r;
 // ⠭ ""-⠭.
 r.x.ax = 0x3125;
 int86(0x2F, &r, &r);
 //  ""-p.
 if(r.h.al == 0x19) return YES; // १⭠  室  
 else return NO;  // १⭠  
}

//   ⭮ 襭 ணࠬ.  १⭮ 
//   - size ࠣ䮢,  MS-DOS ।  襭 status.
//   ᯮ ⮣,  ॡ "楯" TSR 
//   뢠 0, 4, 5  6.  ⠫  ᫥ ᯮ짮 kee()
void tsr(char status, unsigned size) {
 _AH=0x31;
 _AL = status;
 _DX=size;
 geninterrupt(0x21);
}

void TSR_body (void) {};

/////////// Happytxt.cpp
char x0=0x13,y0=0x06; //  

//     ESC (01h)      -   Esc;
//     QUIT (10h)     -   'Q';
//     BAD_PARAMS(FFh) - 室騩 p.
void TSR_screen (void) {
 register ret; char xc,yc;
 asm { mov ah,3; mov bh,0; int 10h; mov yc,dh; mov xc,dl; } // Save cursor
 if (x0+17>max_stolb) x0=max_stolb-17; // ஢ઠ न  
 if (y0+8>max_str) y0=max_str-8;       // 砩 ᬥ ०
AGAIN:
 ret = Happy(); // 믮 ᭮ p
 switch(ret) {
  case 0x10: unload = 1; /*YES*/ break; // Q
  case 0x01: break;		   // ESC
  case 0x47: x0--; goto AGAIN; // Home
  case 0x4F: x0++; goto AGAIN; // End
  case 0x49: y0--; goto AGAIN; // PgUp
  case 0x51: y0++; goto AGAIN; // PgDn
  case 0xff: Sound (800, 500); // Bad - ᨣ 800  0.5 ᥪ㭤
 }
 goto_xy (xc,yc); // Restore cursor
 return;
}

unsigned buf[153]; //   
char Beep=0x03; 
// xxxx xxx1  Y/N
// xxxx xx1x   Y/N
char MES_ATTR,HDR_ATTR,HI_ATTR; // ਡ ᮢ
static char cur=0x08; //   

char Happy (void) {
char *field=
//   H A P P Y
"ķ&"
"ķ ķ&"
"       &"
"ͼ ͼ&"
"       ķ&"
" ᥣ       &"
"        &"
"       ͼ&"
"ͼ"; //17 * 9 = 153
 static char Str[8]; static char input[9];
 // [0] 1/0 Bad/Good step
 // [1] Return code:0x01 - ESC, 0x10 -Quit, 0x02 - Move the window,
 // 0x49 - Up, 0x51 - Down, 0x47 - Left, 0x4F - Right
 // [2],[4],[6] Computer steps
 // [3],[5],[7] Man steps
 // [8] - Rolling on/off
 static unsigned int all=0xffff,happy=0xffff;
 char i,cx,c,k;

 if(video_params() == 0xff) return 0xff;

 get_text(x0, y0, x0+16, y0+8, buf); // ࠭ p
 print_mess (x0,y0,field,MES_ATTR);
 print_mess (x0+0x04,y0,"H A P P Y",HI_ATTR);

 for (;;) {
  if (cur==0x08) { //end of game
   all++;
   if (input[2]+input[4]+input[6]==input[3]+input[5]+input[7]) {
    happy++; Sound (2000,50); Sound (1200,40);
   }
   for (i=0x02; i<0x08; i++) input[0]=0x0a;
   cur=0x02; Beep|=0x02;
  }
  if (Beep&0x02) {
   itoa_ (all,Str); centerstr (x0+0x09,y0+0x05,x0+0x0E,Str,HDR_ATTR);
   itoa_ (happy,Str); centerstr (x0+0x09,y0+0x06,x0+0x0E,Str,HDR_ATTR);
   print_mess(x0+0x01,y0+0x02,"       ",MES_ATTR);
   for (i=0x02; i<=cur; i++) write_char 
    (x0+i+(i&0x01 ? 0x07 : 0x00),y0+2,input[i]+'0',HDR_ATTR);
   Beep&=0xfd;
  }
  cx=x0+cur+( cur&0x01 ? 0x07 : 0x00);
  goto_xy (cx,y0+2);
  do {
   if (cur&0x01) {
    c=kbscan(); //man
    if (c>0x01 && c<0x0c) {  // Counts 1,...,9,0
     if (c==0x0b) k=0x00; // Count 0
     else k=c-0x01; input[8]=0x00; 
    } 
    else {
     if (!input[8]) k=input[cur-0x01]; //    ப⪥
     input[1]=0x00;
     switch (c) {
      case 0x3C: Beep^=0x01; break; // F2 - Sound
      case 0x48: k++; if (k>0x09) k=0x00; input[8]=0x01; break; // Up
      case 0x50: if (k>0x00) k--; else k=0x09; input[8]=0x01; break; // Down
      case 0x1C: input[8]=0x00;break; // Enter
      case 0x01:                    // ESC
      case 0x10: input[1]=c; break; // Q - quit
      case 0x47: if (x0>0) input[1]=c; break; // Home
      case 0x4F: if (x0+17<max_stolb)  input[1]=c; break; // End
      case 0x49: if (y0>0) input[1]=c; break; // PgUp
      case 0x51: if (y0+8<max_str) input[1]=c; // PgDn
     }
     if (input[1]) {
      put_text(x0, y0, x0+16, y0+8, buf); // ⠭ p
      Beep|=0x02; input[cur]=k;
      return (c);
     }
    }
   }
   else k=randcount(); //computer
   input[0]=0x00;
   for (i=0x02; i<cur; i++) if (k==input[i]) input[0]=0x01; //check for repeat
   if ((!input[8]) && input[0] && cur&0x01) Sound (100,10);
   write_char (cx,y0+2,k+'0',HDR_ATTR);
  } while (input[0] || input[8]);
  input[cur]=k; cur++;
 }
}

void centerstr (int x1,int y,int x2,char *s,unsigned char a) {
 // 뢮 業஢ ப  ਡ⮬ a
 int j,wd=strlen_(s),i=x1+((x2-x1)-wd)/2;
 if (i<x1) i=x1;
 for (j=0;*s;s++,j++) {
  if (j==wd) break;
  write_char(i+j,y,*s,a);
 }
}

int strlen_(char *s) {
 register int i=0;
 while (*(s+i)!='\0') i++; 
 return (i);
}

void write_char(int x,int y,unsigned char ch,unsigned char attrib) {
 unsigned char far *v=vid_adr; // (unsigned char far *)0xB8000000L;
 v += ((y*max_stolb + x)<<1);
 *v++ = ch; /*  ᨬ */
 *v = attrib; /*  ਡ */
}

void print_mess (char x,char y,unsigned char *mess,unsigned char attr) {
 unsigned char *ptr=mess; char x0=x;
 while (*ptr!='\0') {
  if (*ptr=='&') { x=x0; y++; }
  else { write_char (x,y,*ptr,attr); x++; }
  ptr++; 
 }
}

char *itoa_ (int n,char *s) {
 int sign; char *t=s;
 if ((sign=n)<0) n=-n;
 do {
  *s++=n%10+'0';
 } while ((n/=10)!=0);
 if (sign<0) *s++='-';
 *s='\0';
 return (strrev_ (t));
}

char *strrev_(char *s) {
 int c; char *t,*p=s;
 for (t=s+strlen_(s)-1; s<t; s++,t--) {
  c=*s; *s=*t; *t=c;
 }
 return (p);
}   

char kbscan(void) {
 char sim;
 asm {  PUSH ES         //C࠭塞 ⥫ ᥣ
	MOV  AH,0x00     //뢠 ᨬ   
	INT  16H
	MOV sim,AH
	POP ES
     }
 return (sim);
}

/* ⠭   x,y */
void goto_xy(char x,char y) {
 asm {
  MOV	AH,0x02
  MOV	DL,x
  MOV	DH,y
  MOV	BH,0
  INT	10H
 }
}

void Sound( int chastota, int pause ) {
 if (Beep&0x01) {
   asm{
	  PUSH  AX   //࠭塞 ᯮ㥬 ॣ
	  PUSH  BX
	  PUSH  CX
	  PUSH  DX
	  PUSH  DI

	  CLI                  //頥 뢠
	  MOV   DI,chastota    //७ᨬ 祭  ॣ
	  MOV   BX,pause

	  MOV   AL,0B6H      //  ॣ ० ⠩
	  OUT   43H,AL
	  MOV   DX,14H       //⥫쭮 ६ =
	  MOV   AX,4F38H     //1331000 / 
	  DIV   DI

	  OUT   42H,AL       // 訩  稪 ⠩ 2
	  MOV   AL,AH
	  OUT   42H,AL       // 訩  稪 ⠩ 2

	  IN    AL,61H       // ⥪ ⠭  
	  MOV   AH,AL        // ࠭   ॣ AH
	  OR    AL,03H       // 
	  OUT   61H,AL
	}
WAIT:asm  MOV   CX,2A00H     //릤 10 
SPKR:asm{
	  LOOP  SPKR
	  DEC   BX           //稪 ⥫쭮 ௠ ?
	  JNZ   WAIT         //. த 砭

	  MOV   AL,AH        //. ⠭ 室 ⠭ 
	  OUT   61H,AL

	  POP   DI           //⠭ ॣ
	  POP   DX
	  POP   CX
	  POP   BX
	  POP   AX
	  STI                // 뢠
	}
 }
 return;
}

char randcount(void) {
 unsigned i=0;
 //asm { mov ah,0; int 1ah; mov li.u[1],cx; mov li.u[0],dx; }
 asm { mov ah,0; int 1ah; mov i,dx; }
 i%=10;
 return (i);
}

////////////////////////////////////////////////////
// #include <dos.h>

//   p 㭪 p  p,  p孨
//   㣮 p c0, s0,  p  - c1, s1  p buf.
//   㭪 Turbo C gettext()  室, ⠪  p⠭ 
//   砩   25 p  p.
void get_text(int c0, int s0, int c1, int s1, unsigned * buf) {
 unsigned far * screen;
 int row, col;
 for(row = s0; row <= s1; row++) {
  screen = (unsigned far *)MK_FP(vid_memory, start_adr + (row * max_stolb + c0) * 2);
  for (col = c0; col <= c1; col++) * buf++ = * screen++;
 }
}

//   p 㭪 ⠭  p,  p孨
//   㣮 p c0, s0,  p  - c1, s1  p buf.
//   㭪 Turbo C puttext()  室, ⠪  p⠭ 
//   砩   25 p  p.
void put_text(int c0, int s0, int c1, int s1, unsigned *buf) {
 unsigned far * screen;
 int row, col;
 for(row = s0; row <= s1; row++) {
  screen = (unsigned far *)MK_FP(vid_memory, start_adr + (row * max_stolb + c0) * 2);
  for (col = c0; col <= c1; col++) * screen++ = *buf++;
 }
}
//////////////////////////////////////////
//    p ⥪ pp -⥬, ᯮ㥬
//    㭪ﬨ 뢮  p.    p:
//      BAD_PARAMS (1) - ⠭ 室騩 p;
//      OK         (0) - ⥪騥 pp ⠭  譨 p.
unsigned char video_params(void) {
 register int cur_mode;
 cur_mode  = * (char far *)MK_FP(0x40, 0x49);
 // ४  砫    ஬.
 if (cur_mode == 7 ) {
//  asm {  mov ax,40h; mov es,ax; mov al,es:[0x10]; and al,0x30; }
//  if (_AL==0x30) { // ஬ ?
   vid_memory = 0xb000; *vid_adr=0xB0000000L; 
//   } // ४
 }
 else vid_memory = 0xb800;
 // ᪫祭 ࠡ  ᪮ ०.
 if(!(cur_mode  == 7 | (cur_mode <= 3))) return 0xff;
 max_str = * (char far *)MK_FP(0x40, 0x84);
 if(max_str == 0) max_str = 24;   // cp ᥣ -  25 p 
 max_stolb = * (char far *)MK_FP(0x40, 0x4a);
 start_adr = * (unsigned far *)MK_FP(0x40, 0x4e);
 if (cur_mode==0 || cur_mode==2 || cur_mode==7) { // White & Black mode
  MES_ATTR=0x07; HDR_ATTR=0x0f; HI_ATTR=0x70; }
 else { MES_ATTR=0x17; HDR_ATTR=0x1E; HI_ATTR=0x5E; } // Color mode
 return 0x00;
}

//   樠 㭪. ⠭ १ ணࠬ
void main(void) {
unsigned char *second=
"        !   ";
unsigned char *first=
"H A P P Yķ&"
" 楫 -  ⫨ ,&"
"   ⢥  뢮 設 3&"
"᫠   ᢮ ⠪, ⮡  &"
"㬬 뫨 ࠢ. ᫠  ⮬    &"
" .                   &"
"  Ctrl-Alt-H  ⨢ ணࠬ   &"
"0,...,9 -  , - ப+Enter &"
"PgUp,PgDn,Home,End - ६  &"
"ESC - 室    F2 -  몫./. &"
"Q-㤠  NSoft,1996"; // 40 * 11
 unsigned size;
 if (video_params() == 0xff) { Sound(800,500); return; }
 print_mess (0x00,0x0D,first,MES_ATTR);
 if( is_installed() == YES) {
  print_mess (0x00,0x0C,second,HI_ATTR);
  return;
 }
 // p p 䫠 p 室  DOS.
 _AH = 0x34; geninterrupt(0x21); inside_DOS_ptr = MK_FP(_ES, _BX);
 // 樠 p, ᯮ㥬 p p祭 ⥪.
 TSR_ss = FP_SEG((unsigned far *)TSR_stack);
 TSR_sp = FP_OFF(TSR_stack) + 1020; // ⥪ p p
 TSR_screen_ss = FP_SEG((unsigned far *) TSR_screen_stack);
 TSR_screen_sp = FP_OFF(TSR_screen_stack) + 1020; // ⥪ p p
 // Cp ap DTA Turbo C.
 TC_DTA = getdta();
 // p p  ⠭  p pp뢠.
 old_int9  = getvect(0x9 );
 old_int13 = getvect(0x13);
 old_int1C = getvect(0x1C);
 old_int28 = getvect(0x28);
 old_int2F = getvect(0x2F);
 // p "p" p 2Fh   ᥣ ISR_int2F().
 movedata(_DS, (unsigned)&old_int2F, _CS, FP_OFF(ISR_int2F) + 9, 4 );
 disable();
 setvect(0x9 , ISR_int9 );
 setvect(0x13, ISR_int13);
 setvect(0x1C, ISR_int1C);
 setvect(0x28, ISR_int28);
 setvect(0x2F, ISR_int2F);
 enable();
 // ⭮ p襭 pp.
 size = _SS + (_SP + 15) / 16 - _psp;
 tsr(0, size);
// return; //  p pp,    믮
}
